/*
  Infiksavaldise ttleja
  Autor: Dan Bogdanov
  12.07.2000

  24.09.2002: parandasin vea unaarse miinuse lugemisel
*/

#ifndef __AVALDIS_H__
#define __AVALDIS_H__

class magasin;
class leksator;
struct lekseem;

class infiksavaldis
{
  public:
    // Parameetrina edastatava avaldise vrtust hakatakse arvutama
    infiksavaldis();
    // Destruktor
    virtual ~infiksavaldis();
    // Arvutab avaldise vrtuse
    int arvuta(char* uus_avaldis);
    // Omistab muutujale vrtuse
    int omista(char taht, char* avaldis);
    // Avaldise vrtus talletatakse siia
    float tulemus;
  private:
    // Mrab tehte prioriteedi
    int prioriteet(lekseem* leks);
    // Sooritab arvutused
    int soorita(lekseem* leks);
    // Haldab tehete jrjekorda ja arvutusi
    int tootlemark(lekseem* leks);

    // Talletab kigi muutujate vrtused
    float muutuja[25];
    // Mrgib, kas muutuja on vrtustatud
    int puudutatud[25];
    // Mrab, kas jrgmine lekseem peaks olema arv
    int ootanarvu;
    // Arvude magasin
    magasin* am;
    // Tehtemrkide magasin
    magasin* tm;
    // Analsaator
    leksator* analysaator;
};

#endif // __AVALDIS_H__

