/*
  Rooma numbrite teisendamine araabia numbriteks
  Autor: Dan Bogdanov

  Algoritm: lpliku olekute hulgaga automaat. Prit A. Isotamme
  Algoritmide & andmestruktuuride loengust 10.09.2002

  Lihtsustatud variant: konstruktsioonid stiilis IM, IC, XM on keelatud.

  24.09.2002
*/

#ifndef __ARAABIA_H__
#define __ARAABIA_H__

class araabia
{
  public:
    // Konstruktor
    araabia (char* rooma);
    // Destruktor
    virtual ~araabia();
    // Tagastab arvu vrtuse
    int vaartus ();

  private:

    // Olek 'start'
    int start (char key);
    // Olek 'I'
    int uks (char key);
    // Olek 'V'
    int viis (char key);
    // Olek 'X'
    int kumme (char key);
    // Olek 'L'
    int viiskummend (char key);
    // Olek 'C'
    int sada (char key);
    // Olek 'D'
    int viissada (char key);
    // Olek 'M'
    int tuhat (char key);

  private:

    char* rooma;
    int arv;
    int pikkus;
    char olek;

    int ic, xc, cc;

};

#endif // __ARAABIA_H__

