/*
 LIFO-tpi magasin lekseemide hoidmiseks
 Autor: Dan Bogdanov
 11.07.2000
 */

#ifndef __MAGASIN_H__
#define __MAGASIN_H__

// Maht, mille magasin saab vaikimisi
#define MAGASINI_MAHT 25

struct lekseem;

class magasin
{
 public:
  // Konstruktor
  magasin();
  // Destruktor
  virtual ~magasin();
  // Thjendab magasini
  void tyhjenda();
  // Tene, kui magasin on thi
  int on_tyhi();
  // Tene, kui magasin on tis
  int on_tais();
  // Paneb lekseemi magasini
  void pane(lekseem* leks);
  // Vtab magasinist pealmise lekseemi
  lekseem* vota();
 public:
  int elemente;
  lekseem* element[MAGASINI_MAHT];
};

#endif // __MAGASIN_H__

