/*
 Leksiline analysaator infiksavaldiste ttlemiseks
 Autor: Dan Bogdanov
 11.07.2000
 */

#ifndef __LEKSATOR_H__
#define __LEKSATOR_H__

typedef struct lekseem
{
    // Muutuja hoiab lekseemi tyypi (defineeritud allpool)
    int tyyp;
    // Arvuline vrtus
    float arv;
    // Lekseemi muu vimalik sisu (tehtemrk, muutuja, veateade)
    char* sisu;
} lekseem;

class leksator
{
  public:
    // Parameetrina edastatavast stringist hakatakse lekseeme lugema
    leksator();
    // Destruktor
    virtual ~leksator();
    // Annab stringi, mida analsima hakatakse
    void alusta(char* uus_string);
    // Loeb stringist jrgmise lekseemi
    lekseem* loelekseem();
  protected:
    // String, millest lekseeme loetakse
    char* string;
    // Arv, mis nitab parseldatavat kohta stringis
    int koht;
};

// Lekseemityybid
#define L_TYHI 0        // Tyhi lekseem
#define L_ARV 1         // Tisarv
#define L_MUUT 2        // Muutuja
#define L_MARK 3        // Tehtemrk
#define L_LOPP 4        // Stringi lpp
#define L_VIGA 5        // Viga stringi parseldamisel

#endif // __LEKSATOR_H__

