/*
 Lihtne LIFO-magasin lekseemide hoidmiseks
 11.07.2000
 */

#include <leksator.h>
#include <magasin.h>

//--Konstruktor---------------------------------------------------------------

magasin::magasin()
{
  elemente=0;
}

//--Destruktor----------------------------------------------------------------
magasin::~magasin()
{
  elemente=0;
}

//--Funktsioon, mis thjendab magasini----------------------------------------

void magasin::tyhjenda ()
{
  elemente=0;
}

//--Kui magasin on tis, siis on funktsiooni vrtus tene--------------------

int magasin::on_tais()
{
  return (elemente==0);
}


//--Kui magasin on thi, siis on funktsiooni vrtus tene--------------------

int magasin::on_tyhi()
{
  return (elemente==0);
}

//--Paneb magasini uue lekseemi-----------------------------------------------

void magasin::pane(lekseem *leks)
{
  // Vaatab, kas magasini mahub veel midagi ja siis talletab ka viida
  if(elemente < MAGASINI_MAHT)
  {
    element[elemente]=leks;
    elemente++;
  }
  else
  {
    leks->tyyp=L_VIGA;
    leks->sisu="Magasin tis!";
  }
}

//--Vtab magasinist sinna viimasena pandud lekseemi--------------------------

lekseem* magasin::vota()
{
  // Kui elemente on, siis vtab neist pealmise
  lekseem *uus=0;
  if(elemente>0)
  {
    elemente--;
    uus=element[elemente];
    return uus;
  }
  else
  {
    uus->tyyp=L_VIGA;
    uus->sisu="Magasin thi!";
    return uus;
  }
}

//--Lpp----------------------------------------------------------------------

