/*
  Araabia numbrite teisendamine rooma numbriteks
  Autor: Dan Bogdanov

  Algoritm: kunagi Tppisteaduste Kooli jaoks kaugppes kirjutatu
  edasiarendus

  24.09.2002
*/

#include <rooma.h>

#include <string.h>

//--Konstruktor---------------------------------------------------------------

rooma::rooma (int a_arv)
{
  arv = a_arv;
}

rooma::rooma (float a_arv)
{
  arv = (int)a_arv;
}

//--Destruktor----------------------------------------------------------------

rooma::~rooma () {}

//--Tagastab arvu rooma numbrite abil-----------------------------------------

char* rooma::vaartus ()
{
  char rooma[1000];
  strcpy (rooma, "");
  int v = arv;

  if (v != 0) {
    if (v < 0) {
      v = v * -1;
      strcat (rooma, "-");
    }
    while (v >= 1000) {
      v -= 1000;
      strcat (rooma, "M");
    }
    if (v >= 900) {
      v -= 900;
      strcat (rooma, "CM");
    }
    if (v >= 500) {
      v -= 500;
      strcat (rooma, "D");
    }
    if (v >= 400) {
      v -= 400;
      strcat (rooma, "CD");
    }
    while (v >= 100) {
      v -= 100;
      strcat (rooma, "C");
    }
    if (v >= 90) {
      v -= 90;
      strcat (rooma, "XC");
    }
    if (v >= 50) {
      v -= 50;
      strcat (rooma, "L");
    }
    if (v >= 40) {
      v -= 40;
      strcat (rooma, "XL");
    }
    while (v >= 10) {
      v -= 10;
      strcat (rooma, "X");
    }
    if (v >= 9) {
      v -= 9;
      strcat (rooma, "IX");
    }
    if (v >= 5) {
      v -= 5;
      strcat (rooma, "V");
    }
    if (v >= 4) {
      v -= 4;
      strcat (rooma, "IV");
    }
    while (v >= 1) {
      v -= 1;
      strcat (rooma, "I");
    }
  } else {
    strcpy (rooma, "O");
  }

  return strdup (rooma);
}

//--Lpp----------------------------------------------------------------------

